<template lang="pug">
  div
    v-toolbar(flat, color='white')
      v-btn(depressed, small, :color="visibility=='all'?'secondary':''", @click="changeVisibility('all')") все задачи
      v-btn(depressed, small, :color="visibility=='active'?'secondary':''", @click="changeVisibility('active')") не готово
      v-btn(depressed, small, :color="visibility=='completed'?'secondary':''", @click="changeVisibility('completed')") готово
      v-divider.mx-2(inset, vertical)
      v-spacer
      v-btn.mb-2(color='primary', dark, to="/new-task") Создать задачу
    v-data-table.elevation-1(:headers='headers', :items='filteredTodos', hide-actions)
      template(slot='items', slot-scope='props')
        td {{ props.item.id }}
        td {{ props.item.title }}
        td {{ props.item.description }}
        td {{ props.item.date }}
        td {{ props.item.done?'готово':'не готово' }}
        td(align="right")
          v-icon.mr-2(small, color="green darken-2", @click='toggleTodo(props.item)')
            | done
          router-link(:to="`/task/${props.item.id}`")
            v-icon.mr-2(small, color="blue darken-2", type="button")
              | edit
          v-icon(small, color="red darken-2", @click='removeTodo(props.item)')
            | delete
</template>
<script>
  import { mapActions } from 'vuex';

  const filters = {
    all: todos => todos,
    active: todos => todos.filter(todo => !todo.done),
    completed: todos => todos.filter(todo => todo.done)
  }

  export default {
    data() { 
        return {
          headers: [
            {
              text: 'id',
              sortable: false,
              value: 'id'
            },
            {
              text: 'задача',
              sortable: false,
              value: 'title'
            },
            {
              text: 'описание',
              sortable: false,
              value: 'description'
            },
            {
              text: 'дата',
              sortable: true,
              value: 'date'
            },
            {
              text: 'состояние',
              align: 'left',
              sortable: false,
              value: 'done'
            },
            {
              text: 'действия',
              align: 'right',
              sortable: false,
              value: 'id'
            },
          ],
          filters,
          visibility: 'all',
        } 
    },
    computed: {
      todos () {
        return this.$store.state.todos
      },
      filteredTodos () {
        return filters[this.visibility](this.todos)
      },
    },
    methods: {
      ...mapActions([
        'toggleTodo',
        'removeTodo',
      ]),
      changeVisibility(status) {
        this.visibility = status;
      }
    },
  }
</script>
